// /************************************************************************\
// *                                                                        *
// *  Matt's SDL Library-ish v0.3                                           *
// *      by Mathew Carr                                                    *
// *                                                                        *
// \************************************************************************/

#ifndef __MATTSDL_H__
#define __MATTSDL_H__

#include <SDL\SDL.h>   // libSDL

void MSDL_event_callback_noop(SDL_Event *sdl_event);

// Array of flags telling what events have taken place.
extern bool MSDL_triggered_event_flags[SDL_NUMEVENTS];

// Array of callbacks for capturing the different events.
extern void (*MSDL_event_callbacks[SDL_NUMEVENTS])(SDL_Event *sdl_event);

void MSDL_UpdateEventsArray(bool MSDL_triggered_event_flags[] = MSDL_triggered_event_flags,
                            void (*MSDL_event_callbacks[])(SDL_Event *sdl_event) = MSDL_event_callbacks);

// All the keystates.
extern Uint8 MSDL_keystates[SDLK_LAST];
// All the previous keystates.
extern Uint8 MSDL_prevkeystates[SDLK_LAST];
// Number of keys, returned from SDL_GetKeyState.
extern int MSDL_numkeys;

void MSDL_GetKeyState();

// All the current mousestates.
extern Uint8 MSDL_mousestates;
// All the previous mousestates.
extern Uint8 MSDL_prevmousestates;
// Mouse position, returned from SDL_GetMouseState.
extern int MSDL_mousex;
extern int MSDL_mousey;

void MSDL_GetMouseState(Uint8 *MSDL_mousestates = &MSDL_mousestates, int *MSDL_mousex = &MSDL_mousex,
                                                                     int *MSDL_mousey = &MSDL_mousey);

int MSDL_KeyHeld(int key_index);
int MSDL_KeyPressed(int key_index);
int MSDL_KeyRaised(int key_index);
int MSDL_KeyIdle(int key_index);

void MSDL_Delay(Uint32 time);

// The time the stopwatch was started. (This time is counted as zero)
extern Uint32 MSDL_start_time;

void MSDL_SetStartTime(void);

void MSDL_SpinlockUntilStopwatch(Uint32 stopwatch_time);

#endif // __MATTSDL_H__
