// GL extensions to VectorMaths by Mathew Carr

#ifndef __GLVECTORMATHS_H__
#define __GLVECTORMATHS_H__

#include <GL/gl.h>
#include "VectorMaths.h"

// This is a glue structure that safely transforms
// Vector3Ds into GLfloat form for OpenGL functions.

struct GLfloatVector3D
{
   GLfloat values[4];

   GLfloatVector3D(const Vector3D &f);
   GLfloatVector3D()
   {
      values[0] = 0.0f;
      values[1] = 0.0f;
      values[2] = 0.0f;
      values[3] = 1.0f;
   }

   const GLfloat *Values() const;
};

// Construct GLfloatVector3Ds from existing vectors.
inline GLfloatVector3D::GLfloatVector3D(const Vector3D &f)
{
   this->values[0] = f.x;
   this->values[1] = f.y;
   this->values[2] = f.z;
   this->values[3] = 1.0f;
}

inline const GLfloat *GLfloatVector3D::Values() const
{
   return this->values;
}

#endif // __GLVECTORMATHS_H__
